<script>
import { mapGetters, mapState } from 'vuex';
import { POSE_TYPES_MAPPER, POSE_ACTIONS } from '~/helpers/libraries.js';

import AnimRigPosesGrid from '~/components/anim-rig/poses-grid.vue';
import AnimRigPosesDetail from '~/components/anim-rig/poses-detail.vue';

function isLetter(c) {
  return c.toLowerCase() != c.toUpperCase();
}

export default {
  name: `page-search`,
  components: { AnimRigPosesGrid, AnimRigPosesDetail },
  data() {
    return {
      onlyPublicLibs: true,
      selectedLib: null,
      selectedPose: null,
    };
  },
  computed: {
    ...mapGetters('projects', [ 'projectLibraries', 'isWriter' ]),
    ...mapState({
      selectedWebsocket: (state) => state.websockets.selectedWebsocket,
      username: (state) => state.users.currentUser.username,
      flip: (state) => state.poses.flip,
      applyOnSelected: (state) => state.poses.applyOnSelected,
      importAtCurrentFrame: (state) => state.poses.importAtCurrentFrame,
    }),
    iAmWriter() {
      return this.isWriter(this.username);
    },
    hasSelectedPose() {
      return this.selectedPose !== null;
    },
    searchResults() {
      const search = this.$route.params.id.toLowerCase();
      const p = this.onlyPublicLibs;
      return this.projectLibraries.reduce((acc, { id, name, poses, favorite, public: _p }) => {
        if (p && !_p) return acc;

        const validPoses = poses.filter((pose) => {
          const allWords = search.split(' ').filter((w) => w.length > 0);
          const words = [], antiwords = [];
          for (const w of allWords) {
            if (w.startsWith('*')) {
              if (w.length > 2 && isLetter(w.charAt(2))) words.push(w.slice(1));
            }
            else if (w.startsWith('-')) {
              if (w.length > 1) antiwords.push(w.slice(1));
            }
            else {
              words.push(w);
            }
          }

          for (const w of words) {
            if (pose.name.toLowerCase().indexOf(w) == -1) return false;
          }
          for (const w of antiwords) {
            if (pose.name.toLowerCase().indexOf(w) > -1) return false;
          }
          return true;
        });
        if (validPoses.length > 0)
          acc.push({
            lib: { id, name, favorite, public: _p },
            poses: validPoses,
          });
        return acc;
      }, []);
    },
  },
  methods: {
    setCheckboxValue(action, data) {
      this.$store.dispatch(`poses/${action}`, data);
    },
    applyPose(pressingCtrl, poseType = null) {
      if (this.selectedWebsocket === ``) {
        return;
      }
      const action = POSE_ACTIONS[pressingCtrl ? 'extend' : 'replace'];
      if (poseType === null)
        poseType = this.poseType;
      this.$store.dispatch(`websockets/sendData`, {
        name: this.selectedWebsocket,
        data: { operator: `lfs.colibri_apply_pose`,
                pose_b64: btoa(JSON.stringify(this.pose.data)),
                flip: this.flip,
                apply_on_selected: this.applyOnSelected,
                merge_factor: 100,
                initial_merge: true,
                pose_type: POSE_TYPES_MAPPER[poseType],
                action,
                current_frame: this.importAtCurrentFrame, }
      });
    },
  }
}
</script>

<template>
  <div>
    <!-- RIGHT DRAWER -->
    <v-navigation-drawer
      :value="selectedLib !== null && selectedPose !== null"
      @input="(value) => { if (!value) { selectedLib = null; selectedPose = null; } }"
      absolute
      right
      temporary
      hide-overlay
    >
      <anim-rig-poses-detail
        simple
        v-if="selectedLib"
        :lib="selectedLib"
        :pose="selectedPose"
      />
    </v-navigation-drawer>

    <div class="text-center text-h6">
      {{ $t(`search.searching-for`) }}<span class="ml-2">"{{ $route.params.id }}"...</span>
      <div v-if="searchResults.length === 0" class="text-lg-overline">
        {{ $t(`common.no-results`) }}
      </div>
    </div>
    <v-row no-gutters v-if="iAmWriter" justify="center" class="mb-2">
      <v-checkbox
        v-model="onlyPublicLibs"
        hide-details
        class="mr-2"
      >
        <template #label>
          <div class="text-sm-caption">
            {{ $t(`search.only-public-libs`) }}
          </div>
        </template>
      </v-checkbox>
      <v-checkbox
        :input-value="flip"
        @change="(value) => setCheckboxValue('updateFlip', { flip: value })"
        hide-details
        class="mr-2"
      >
        <template #label>
          <div class="text-sm-caption">
            {{ $t(`anim-rig.lib-page.flip`) }}
          </div>
        </template>
      </v-checkbox>
      <v-checkbox
        :input-value="applyOnSelected"
        @change="(value) => setCheckboxValue('updateApplyOnSelected', { applyOnSelected: value })"
        hide-details
        class="mr-2"
      >
        <template #label>
          <div class="text-sm-caption">
            {{ $t(`anim-rig.lib-page.apply-on-selected`) }}
          </div>
        </template>
      </v-checkbox>
      <v-checkbox
        :input-value="importAtCurrentFrame"
        @change="(value) => setCheckboxValue('updateImportAtCurrentFrame', { importAtCurrentFrame: value })"
        hide-details
      >
        <template #label>
          <div class="text-sm-caption">
            {{ $t(`anim-rig.lib-page.import-at-current-frame`) }}
          </div>
        </template>
      </v-checkbox>
    </v-row>
    <template v-if="searchResults.length > 0">
      <div v-for="res in searchResults" :key="res.lib.id">
        <cbr-card
          :to="{ path: localePath(`/anim-rig/${res.lib.name}`), query: $route.query }"
          class="card mt-4"
        >
          <v-row no-gutters>
            <v-icon class="mr-2">
              {{ res.lib.favorite ? `mdi-star` : `mdi-star-outline` }}
            </v-icon>
            <v-icon v-if="res.lib.public" class="mr-2">mdi-web</v-icon>
            <div class="text-subcaption">{{ res.lib.name }}</div>
          </v-row>
        </cbr-card>
        <anim-rig-poses-grid
          :lib="res.lib.name"
          :items="res.poses"
          @select="(pose) => { selectedPose = pose; selectedLib = res.lib.name; }"
        />
      </div>
    </template>
  </div>
</template>

<style scoped>
</style>
